//+------------------------------------------------------------------+
//|                                                   Statistica.mq4 |
//|                                                            Erics |
//|                                                  erics.fx@tut.by |
//+------------------------------------------------------------------+
#property copyright "Erics"
#property link      "erics.fx@tut.by"

#define CSVseparator ';'
#define DecimalPoint ','

extern bool   HighLow = True;
extern int    StartHour = 0;
extern int    EndHour = 24;
extern int    StartDayW = 1;
extern int    EndDayW = 5;
extern double NormalizeRate = 0;
extern int    GroupBy = 5;
extern bool   Integral = False;
extern string OutFileName = "None";

//   .    "  "
//     ,   .

// HighLow         High-Low   Close-Open
// StartHour       
// EndHour         
//                (  , CET:  - 8-18,  - 9-19, - - 15-22,  - 16-23,
//                  - 21-6   23-8 ,  - 22-7   0-9 ,
//                  - 1-9   2-10 ,   - 2-10   3-11 .
// StartDayW       
// EndDayW          (1 = )
// NormalizeRate  ,     ,    
//                  0,     ,     %,
//                     NormalizeRate ( )
// GroupBy           -  ,     
// Integral           
// OutFileName       .     \tester\files\

int maxval, allbars, dt0, dtn;
double Norma, av, sko, sumx, sumx2;
int p[5000];
//double st, en;

void init() {}

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
void deinit()
{ int i, j;
  double s;
  string v;
  
  //  
  if (TimeHour(Time[0])>=StartHour && TimeHour(Time[0])<=EndHour && TimeDayOfWeek(Time[0])>=StartDayW && TimeDayOfWeek(Time[0])<=EndDayW) {
  //   
     if (NormalizeRate==0) Norma = Close[0]/Point; else Norma = NormalizeRate/Point;
     if (HighLow) i = MathRound((High[0] - Low[0])/Close[0]*Norma); else i = MathRound(MathAbs(Open[0] - Close[0])/Close[0]*Norma); //  
     p[i]++; sumx+=0.0001*i; sumx2+=0.0001*i*i;
     if (i>maxval) maxval = i;
     allbars++;
     dtn = TimeCurrent();
  }
  av =  10000.0*sumx/allbars;
  sko = MathSqrt((allbars*sumx2 - sumx*sumx*10000.0)/allbars*10000.0/(allbars-1));
  
  Print(" : ", allbars);
  Print(": ", maxval);
  Print(": ", av);
  Print(": ", sko);
  if (GroupBy<1) GroupBy = 1;
  for(i=0;i<=maxval;i+=GroupBy) {
    if (!Integral) s = 0;
    for(j=0;j<GroupBy;j++) s+=100.0*p[i+j]/allbars;
    Print(i, "-", i+GroupBy-1, " ", s);
  }
  
  if (OutFileName!="None") {
  //   
     int h = FileOpen(OutFileName, FILE_CSV|FILE_WRITE, CSVseparator);
     if (h>0) {
       FileWrite(h, ":", Symbol());
       FileWrite(h, ":", TimeToStr(dt0, TIME_DATE|(TIME_MINUTES*(Period()<PERIOD_D1))));
       FileWrite(h, ":",  TimeToStr(dtn, TIME_DATE|(TIME_MINUTES*(Period()<PERIOD_D1))));
       if (HighLow) v = "High-Low"; else v = "|Close-Open|";
       FileWrite(h, ":", v);
       FileWrite(h, ", :", Period());
       if (Period()<PERIOD_D1) {
         FileWrite(h, ", :", StartHour);
         FileWrite(h, ", :", EndHour);
       }
       FileWrite(h, ",  .:", StartDayW);
       FileWrite(h, ",  .:", EndDayW);
       FileWrite(h, " :", allbars);
       FileWrite(h, ":", maxval);
       FileWrite(h, ":", comma(av));
       FileWrite(h, ":", comma(sko));
       FileWrite(h, "");
       FileWrite(h, "", ", %");
       for(s=0,i=0;i<=maxval;i+=GroupBy) {
         if (!Integral) s = 0;
         for(j=0;j<GroupBy;j++) s+=100.0*p[i+j]/allbars;
         if (GroupBy>1) FileWrite(h, i + "-" + (i+GroupBy-1) + "", comma(s));
            else FileWrite(h, i + "", comma(s));
       }
       
       FileClose(h);
     }
  }
}

int start()
{ static datetime prevtime;
  static bool fst = true;
  int i;

  if (Time[0]==prevtime) return(0);
  prevtime = Time[0];
  //  
  if (TimeHour(Time[1])>=StartHour && TimeHour(Time[1])<=EndHour && TimeDayOfWeek(Time[1])>=StartDayW && TimeDayOfWeek(Time[1])<=EndDayW) {
  //   
     if (NormalizeRate==0) Norma = Close[0]/Point; else Norma = NormalizeRate/Point;
     if (HighLow) i = MathRound((High[1] - Low[1])/Close[1]*Norma); else i = MathRound(MathAbs(Open[0] - Open[1])/Close[1]*Norma); //  
     p[i]++; sumx+=0.0001*i; sumx2+=0.0001*i*i;
     if (i>maxval) maxval = i;
     allbars++;
     if (fst) { dt0 = Time[1]; fst=false; }
     dtn = Time[0];
  }
  return(0);
}

string comma(string s)
{ string ss;
  int p;
  
  if (DecimalPoint=='.') return(s);
  p = StringFind(s, ".", 0);
  if (p<0) return(s);
  ss = StringSetChar(s, p, DecimalPoint);
  return(ss);
}
//+------------------------------------------------------------------+